mod Maux

incl Mtex

rem 
  \para \bf  Initial primitive recursive functions.  \end 

rem 
  \para \it  Zero function.  \end 

fun Z 
  Z(x) = 0

rem 
  \para \it  Successor function.  \end 

fun Ss 'Tex_f1_comp_ss'
  Ss(x) = x+1

rem 
  \para \it  Identities (projections).  \end 

fun I 
  I(x) = x

fun/2 I_2_1 'Tex_f2_comp_i_2_1'
  I_2_1(x1,x2) = x1

fun/2 I_2_2 'Tex_f2_comp_i_2_2'
  I_2_2(x1,x2) = x2

fun/3 I_3_1 'Tex_f3_comp_i_3_1'
  I_3_1(x1,x2,x3) = x1

fun/3 I_3_2 'Tex_f3_comp_i_3_2'
  I_3_2(x1,x2,x3) = x2

fun/3 I_3_3 'Tex_f3_comp_i_3_3'
  I_3_3(x1,x2,x3) = x3

rem 
  \para \bf  Some primitive recursive functions.  \end 

fun/3 D1 'Tex_f3_comp_d1'
  D1(0,y,z) = z
  D1(x+1,y,z) = y

fun/2 Exp 'Tex_f2_pa_exp'
  Exp(x,0) = 1
  Exp(x,y+1) = x*Exp(x,y)

rem 
  \para \bf  Boolean functions.  \end 

fun Notf 'Tex_f1_bool_notf'
  Notf(x) = D1(x,0,1)

fun/2 Andf 'Tex_f2_bool_andf'
  Andf(x,y) = D1(x,D1(y,1,0),0)

fun/2 Orf 'Tex_f2_bool_orf'
  Orf(x,y) = Notf Andf(Notf(x),Notf(y))

fun/2 Impf 'Tex_f2_bool_impf'
  Impf(x,y) = Orf(Notf(x),y)

fun/2 Ifff 'Tex_f2_bool_ifff'
  Ifff(x,y) = Andf(Impf(x,y),Impf(y,x))

rem 
  \para \bf  Characteristic functions.  \end 

fun/2 Eqf 'Tex_f2_char_eqf'
  Eqf(x,y) = 1 <- x = y
  Eqf(x,y) = 0 <- x != y

fun/2 Nef 'Tex_f2_char_nef'
  Nef(x,y) = 1 <- x != y
  Nef(x,y) = 0 <- x = y

fun/2 Lef 'Tex_f2_char_lef'
  Lef(x,y) = 1 <- x <= y
  Lef(x,y) = 0 <- x > y

fun/2 Ltf 'Tex_f2_char_ltf'
  Ltf(x,y) = 1 <- x < y
  Ltf(x,y) = 0 <- x >= y

fun/2 Gef 'Tex_f2_char_gef'
  Gef(x,y) = 1 <- x >= y
  Gef(x,y) = 0 <- x < y

fun/2 Gtf 'Tex_f2_char_gtf'
  Gtf(x,y) = 1 <- x > y
  Gtf(x,y) = 0 <- x <= y

rem 
  \para \bf  Catalan pairing function.  \end 

rem 
  \para \it  Projection functions.  \end 

fun Proj1 'Tex_f1_pp_proj1'
  Proj1(0) = 0
  Proj1(v,w) = v

fun Proj2 'Tex_f1_pp_proj2'
  Proj2(0) = 0
  Proj2(v,w) = w

rem 
  \para \it  Indexing function.  \end 

fun/2 Sub 'Tex_f2_ln_sub'
  Sub((v,w),0) = v
  Sub((v,w),i+1) = Sub(w,i)

rem 
  \para \it  Length of sequences.  \end 

fun L 
  L(0) = 0
  L(v,w) = L(w)+1

rem 
  \para \it  N-tuples.  \end 

pred/2 Tp 
  Tp(1,x1)
  Tp(n+2,x1,x) <- Tp(n+1,x)

fun/3 Sel 'Tex_f3_comp_sel'
  Sel(1,x1,1) = x1
  Sel(n+2,(x1,x),1) = x1
  Sel(n+2,(x1,x),i+2) = Sel(n+1,x,i+1)

